#include <gdbm.h>
#include <string.h>
#include <stdio.h>

int main(int argc, char **argv)
{
    datum key, val;
    datum nextkey;
    GDBM_FILE db;
    char *keyptr;
    char *valptr;

    if (argc != 2)
	{
	fprintf(stderr,"usage: %s <dbfile>\n",argv[0]);
	return 1;
	}

    db = gdbm_open(argv[1],0,GDBM_READER,0644,0);
    
    key = gdbm_firstkey (db);
    while ( key.dptr )
        {
        nextkey = gdbm_nextkey ( db, key );
    		keyptr = (char *)malloc(key.dsize);
	    	strncpy(keyptr,key.dptr,key.dsize);
			keyptr[key.dsize] = '\0';
        val = gdbm_fetch(db,key);
	    	valptr = (char *)malloc(val.dsize);
	    	strncpy(valptr,val.dptr,val.dsize);
			valptr[val.dsize] = '\0';
	printf("--------------------------------------------------\n");
        printf("Name: %s\n--------------------------------------------------\n%s\n\n",keyptr, valptr);
		free(keyptr);
		free(valptr);
        key = nextkey;
        }
    gdbm_close(db);

    return 0;
}
